XIncludeFile "TabBarGadget.pbi"


Enumeration
	#Window
	#Image
	#Gadget_TabBar
	#Gadget_CloseButton
	#Gadget_EmptyButton
	#Gadget_MirroredTabs
	#Gadget_TextCutting
	#Gadget_NoTabMoving
	#Gadget_TabRounding
	#Gadget_MultiLine
	#Gadget_BottomLine
	#Gadget_PopupButton
	#Gadget_Editable
	#Gadget_MultiSelect
	#Gadget_Item
	#Gadget_ItemBackColor
	#Gadget_ItemFrontColor
	#Gadget_ItemText
	#Gadget_ItemImage
	#Gadget_ItemDisable
	#Gadget_Container
	#PopupMenu
EndEnumeration


Procedure GetItemGadgetState()
	Select GetGadgetState(#Gadget_Item)
		Case -1
			ProcedureReturn #TabBarGadgetItem_None
		Case 0
			ProcedureReturn #TabBarGadgetItem_NewTab
		Default
			ProcedureReturn GetGadgetState(#Gadget_Item)-2
	EndSelect
EndProcedure

Procedure UpdateItemGadget(Position)
	Protected Index
	ClearGadgetItems(#Gadget_Item)
	AddGadgetItem(#Gadget_Item, #PB_Default, "NewTab")
	For Index = 1 To CountTabBarGadgetItems(#Gadget_TabBar)
		AddGadgetItem(#Gadget_Item, #PB_Default, "Position "+Str(Index-1))
	Next
	SetTabBarGadgetState(#Gadget_TabBar, Position)
	SetGadgetState(#Gadget_Item, Position+1)
	SetGadgetText(#Gadget_ItemText, GetTabBarGadgetItemText(#Gadget_TabBar, GetItemGadgetState()))
EndProcedure



Define Color.i, FileName.s, Position.i

OpenWindow(#Window, 0, 0, 1200, 450, "TabBarGadget", #PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_SizeGadget)

TabBarGadget(#Gadget_TabBar, 5, 5, WindowWidth(#Window)-10, 0, #Null, #Window)
	ExamineDirectory(1, "Q:\PureBasic\Includes", "*.pbi")
	While NextDirectoryEntry(1)
		AddTabBarGadgetItem(#Gadget_TabBar, #PB_Default, DirectoryEntryName(1))
	Wend
TabBarGadgetToolTip(#Gadget_TabBar, "%ITEM", "Neue Karte", "Karte schlieen")

TabBarGadgetItemToolTip(#Gadget_TabBar, 0, "Q:\PureBasic\Projekte\TabBarGadget\Help\AddTabBarGadgetItem.png")


ContainerGadget(#Gadget_Container, 5, 30, WindowWidth(#Window)-10, 230, #PB_Container_Raised)

	Frame3DGadget(#PB_Any, 5, 5, 150, 255, "Attribute")
	CheckBoxGadget(#Gadget_CloseButton, 15, 25, 130, 20, "Schlieen-Schaltflche")
	CheckBoxGadget(#Gadget_EmptyButton, 15, 45, 130, 20, "'Neu'-Registerkarte")
	CheckBoxGadget(#Gadget_MirroredTabs, 15, 65, 130, 20, "Spiegeln")
	CheckBoxGadget(#Gadget_TextCutting, 15, 85, 130, 20, "Textkrzung")
	CheckBoxGadget(#Gadget_NoTabMoving, 15, 105, 130, 20, "keine Verschiebung")
	CheckBoxGadget(#Gadget_MultiLine, 15, 125, 130, 20, "Mehrzeilig")
	CheckBoxGadget(#Gadget_BottomLine, 15, 145, 130, 20, "Begrenzungslinie")
	CheckBoxGadget(#Gadget_PopupButton, 15, 165, 130, 20, "Popupschalter")
	CheckBoxGadget(#Gadget_Editable, 15, 185, 130, 20, "Editierbar")
	CheckBoxGadget(#Gadget_MultiSelect, 15, 205, 130, 20, "Mehrfachauswahl")
	TextGadget(#PB_Any, 15, 233, 70, 20, "Rundung:")
	SpinGadget(#Gadget_TabRounding, 90, 230, 50, 20, 0, 20, #PB_Spin_Numeric)
	SetGadgetState(#Gadget_TabRounding, GetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_TabRounding))
	
	Frame3DGadget(#PB_Any, 160, 5, 250, 120, "Registerkarte")
	TextGadget(#PB_Any, 170, 28, 50, 20, "Position:")
	ComboBoxGadget(#Gadget_Item, 220, 25, 100, 20)
	ButtonGadget(#Gadget_ItemBackColor, 170, 50, 100, 20, "Hintergrundfarbe")
	ButtonGadget(#Gadget_ItemFrontColor, 275, 50, 100, 20, "Textfarbe")
	TextGadget(#PB_Any, 170, 78, 30, 20, "Text:")
	StringGadget(#Gadget_ItemText, 200, 75, 175, 20, GetTabBarGadgetText(#Gadget_TabBar))
	CheckBoxGadget(#Gadget_ItemDisable, 170, 100, 100, 20, "Deaktivieren")
	ButtonGadget(#Gadget_ItemImage, 275, 100, 100, 20, "Bild oder Icon", #PB_Button_Toggle)

 CloseGadgetList()

UsePNGImageDecoder()
UpdateItemGadget(0)

CreatePopupMenu(#PopupMenu)
	MenuItem(1, "Eins")
	MenuItem(2, "Zwei")
	MenuItem(3, "Drei")

Repeat
	
	Select WaitWindowEvent()
		
		Case #PB_Event_CloseWindow
			
			End
			
		Case #PB_Event_SizeWindow
			
			ResizeGadget(#Gadget_TabBar, 5, 5, WindowWidth(#Window)-10, #PB_Ignore)
			ResizeGadget(#Gadget_Container, #PB_Ignore, #PB_Ignore, WindowWidth(#Window)-10, WindowHeight(#Window)-GadgetHeight(#Gadget_TabBar)-10)
			UpdateTabBarGadget(#Gadget_TabBar)
			
		Case #PB_Event_Gadget
			
			Select EventGadget()
				
				Case #Gadget_TabBar
					Select TabBarGadgetEvent(#Gadget_TabBar)
						Case #TabBarGadgetEvent_NewTab
							Debug "NewTab"
							Position = AddTabBarGadgetItem(#Gadget_TabBar, #PB_Default, "New tab")
							Define n
							For n = 1 To 1000
								SetTabBarGadgetItemColor(#Gadget_TabBar, 0, #PB_Gadget_BackColor, Random($FFFFFF))
							Next
							UpdateItemGadget(Position)
						Case #TabBarGadgetEvent_CloseTab
							Debug "CloseTab"
							RemoveTabBarGadgetItem(#Gadget_TabBar, EventTab(#Gadget_TabBar))
						Case #TabBarGadgetEvent_Change
							Debug "Change"
							SetGadgetState(#Gadget_Item, GetTabBarGadgetState(#Gadget_TabBar)+2)
							SetGadgetText(#Gadget_ItemText, GetTabBarGadgetItemText(#Gadget_TabBar, EventTab(#Gadget_TabBar)))
						Case #TabBarGadgetEvent_PopupButton
							Debug "PopupButton"
							DisplayPopupMenu(#PopupMenu, WindowID(#Window))
						Case #TabBarGadgetEvent_Resized
							Debug "Resized"
							ResizeGadget(#Gadget_Container, #PB_Ignore, GadgetHeight(#Gadget_TabBar)+5, #PB_Ignore, #PB_Ignore)
							Debug GadgetHeight(#Gadget_TabBar)
						Case #TabBarGadgetEvent_TabEdited
							Debug "TabEdited"
						Case #TabBarGadgetEvent_TabSwapped
							Debug "TabSwapped"
					EndSelect
					
				Case #Gadget_CloseButton
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_CloseButton, GetGadgetState(#Gadget_CloseButton))
				Case #Gadget_EmptyButton
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_NewTab, GetGadgetState(#Gadget_EmptyButton))
				Case #Gadget_MirroredTabs
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_MirroredTabs, GetGadgetState(#Gadget_MirroredTabs))
				Case #Gadget_TextCutting
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_TextCutting, GetGadgetState(#Gadget_TextCutting))
				Case #Gadget_NoTabMoving
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_NoTabMoving, GetGadgetState(#Gadget_NoTabMoving))
				Case #Gadget_TabRounding
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_TabRounding, GetGadgetState(#Gadget_TabRounding))
				Case #Gadget_MultiLine
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_MultiLine, GetGadgetState(#Gadget_MultiLine))
				Case #Gadget_BottomLine
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_BottomLine, GetGadgetState(#Gadget_BottomLine))
				Case #Gadget_PopupButton
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_PopupButton, GetGadgetState(#Gadget_PopupButton))
				Case #Gadget_Editable
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_Editable, GetGadgetState(#Gadget_Editable))
				Case #Gadget_MultiSelect
					SetTabBarGadgetAttribute(#Gadget_TabBar, #TabBarGadget_MultiSelect, GetGadgetState(#Gadget_MultiSelect))
				
				Case #Gadget_Item
					SetGadgetText(#Gadget_ItemText, GetTabBarGadgetItemText(#Gadget_TabBar, GetItemGadgetState()))
				Case #Gadget_ItemBackColor
					Color = GetTabBarGadgetItemColor(#Gadget_TabBar, GetTabBarGadgetState(#Gadget_TabBar), #PB_Gadget_BackColor)
					Color = ColorRequester(Color)
					If Color > -1
						SetTabBarGadgetItemColor(#Gadget_TabBar, GetItemGadgetState(), #PB_Gadget_BackColor, Color)
					EndIf
				Case #Gadget_ItemFrontColor
					Color = GetTabBarGadgetItemColor(#Gadget_TabBar, GetTabBarGadgetState(#Gadget_TabBar), #PB_Gadget_FrontColor)
					Color = ColorRequester(Color)
					If Color > -1
						SetTabBarGadgetItemColor(#Gadget_TabBar, GetItemGadgetState(), #PB_Gadget_FrontColor, Color)
					EndIf
				Case #Gadget_ItemText
					SetTabBarGadgetItemText(#Gadget_TabBar, GetItemGadgetState(), GetGadgetText(#Gadget_ItemText))
				Case #Gadget_ItemDisable
					DisableTabBarGadgetItem(#Gadget_TabBar, GetItemGadgetState(), GetGadgetState(#Gadget_ItemDisable))
				Case #Gadget_ItemImage
					If GetGadgetState(#Gadget_ItemImage)
						FileName = OpenFileRequester("Image", "", "Images (*.bmp;*.png)|*.bmp;*.png", 0)
						If FileName And LoadImage(#Image, FileName)
							SetTabBarGadgetItemImage(#Gadget_TabBar, GetItemGadgetState(), ImageID(#Image))
						EndIf
					Else
						SetTabBarGadgetItemImage(#Gadget_TabBar, GetItemGadgetState(), #Null)
					EndIf
					
			EndSelect
			
	EndSelect
	
ForEver

; IDE Options = PureBasic 5.10 Beta 2 (Windows - x64)
; CursorPosition = 58
; FirstLine = 29
; Folding = --
; EnableXP
; EnableCompileCount = 3
; EnableBuildCount = 0